int numCells;

boolean [ ] [ ] cells; // true = alive, false = dead

void setup()
{
  size(1000, 1000);
  numCells = width / 10;
  
  cells = new boolean[numCells][numCells]; // create the array
  
  // Set a random board configuration to begin
  for (int i = 0; i < numCells; i = i + 1)
  {
    for (int j = 0; j < numCells; j = j + 1)
    {
      int value = int(random(2)); // pick a number between 0 and 1
      if (value == 0)
      {
        cells[i][j] = false;
      }
      else
      {
        cells[i][j] = true;
      }
    }
  }
}

void draw ()
{
  background(150);
  
  for (int row = 0; row < numCells; row = row + 1)
  {
    // for each row...
    for (int col = 0; col < numCells; col = col + 1)
    {
      // ... draw each column
      if (cells[row][col] == true)
      {
        fill(0,255,0); // green means alive
      }
      else
      {
        fill(0); // black means the cell is dead
      }
      rect(10 * col, 10 * row, 10, 10);
    }
  }
} // end of draw()

void mousePressed()
{  
  applyRules();
}

void applyRules()
{
  boolean[][] duplicate = new boolean[numCells][numCells];
  
  for (int row = 1; row < numCells - 1; row = row + 1)
  {
    for (int col = 1; col < numCells - 1; col = col + 1)
    {
      int liveNeighbors = 0;
      
      for (int top = row - 1; top < row + 2; top = top + 1)
      {
        for (int side = col - 1; side < col + 2; side = side + 1)
        {
          if (cells[top][side] == true)
          {
            liveNeighbors = liveNeighbors + 1;
          }
        }
      }
      
      if (cells[row][col] == true)
      {
        liveNeighbors = liveNeighbors - 1; // ignore current cell
      }
      
      // Apply our rules
      duplicate[row][col] = cells[row][col];
      
      if (cells[row][col] == false && liveNeighbors == 3)
      {
        duplicate[row][col] = true; // spring to life
      }
      else if (cells[row][col] == true && liveNeighbors < 2)
      {
        duplicate[row][col] = false;
      }
      else if (cells[row][col] == true && liveNeighbors > 3)
      {
        duplicate[row][col] = false;
      }
    }
  }
  
  cells = duplicate;
}