class Light
{
  int x;
  int y;
  int mode; // 0 = RED, 1 = GREEN, 2 = YELLOW
  
  public Light (int x1, int y1) // constructor
  {
    x = x1;
    y = y1;
    mode = int(random(3));
  }
  
  public void show()
  {
    if (mode == 0) // RED
    {
      fill(100);
      rect(x, y, 70, 70);
      fill(200, 0, 0);
      ellipse(x, y, 65, 65);
    }
    else if (mode == 1) // green
    {
      fill(100);
      ellipse(x, y, 70, 70);
      fill(0, 200, 0);
      rect(x, y, 50, 50);
    }
    else // yellow
    {
      fill(100);
      triangle(x, y-70, x+40, y+40, x-40, y+40);
      fill(252, 252, 8);
      ellipse(x, y, 35, 35);
    }
  }
  
  public void change()
  {
//    mode = mode + 1; // 0 -> 1 or 1 -> 2
//    
//    if (mode > 2)
//    {
//      mode = 0;
//    }
    
    mode = (mode + 1) % 3;
    
  } // end of change()
  
  public void update(char k)
  {
    if (mode == 0 && k == 'r')
    {
      y = y - 5; // move up
    }
    else if (mode == 0 && k == 'f')
    {
      y = y + 5; // move down
    }
    else if (mode == 1 && k == 'g')
    {
      x = x + 5; // move right
    }
    else if (mode == 1 && k == 'b')
    {
      x = x - 5; // move left
    }
    else if (mode == 2 && k == 'y')
    {
      x = x + 5; // move up
      y = y - 5; // move to the right
    }
    else if (mode == 2 && k == 'h')
    {
      x = x - 5;
      y = y + 5; // move down and to left
    }
  } // end of update()
  
  
} // end of Light class

Light [ ] array;

void setup ()
{
  size(500, 500);
  rectMode(CENTER);
  
  array = new Light[1000];
  
  for (int i = 0; i < array.length; i = i + 1)
  {
    array[i] = new Light(int(random(500)), int(random(500)));
  }
}

void draw()
{
  background(25);
  for (int x = 0; x < array.length; x = x + 1)
  {
    array[x].show();
  }
}

void mousePressed()
{
  println("Everybody change!");
  for (int i = 0; i < array.length; i = i + 1)
  {
    array[i].change();
  }
}

void keyPressed()
{
  for (int i = 0; i < array.length; i = i + 1)
  {
    array[i].update(key);
  }
}