boolean [ ] lights; // true = on, false = off

void setup()
{
  size(500, 500);
  lights = new boolean[3];
  
  for (int i = 0; i < lights.length; i = i + 1)
  {
    lights[i] = false;
  }
}

void draw()
{
  background(150);
  
  for (int i = 0; i < lights.length; i = i + 1)
  {
    if (lights[i] == false) // off
    {
      fill(0);
    }
    else // on
    {
      fill(252, 252, 13);
    }
    
    rect(i*30 + 40, 235, 30, 30);
  }
}

void mousePressed()
{
  // flip first (rightmost) light
  // Take the old value and apply logical NOT to reverse it
  lights[lights.length - 1] = !(lights[lights.length - 1]);
  
  if (lights[lights.length - 1] == false)
  {
    // flip the next light to the left, etc.
    int position = lights.length - 2; // next-to-last position
    boolean wasChanged = true;
    
    while (wasChanged)
    {
      lights[position] = !lights[position];
      wasChanged = false;
      
      if (lights[position] == false && position > 0)
      {
        wasChanged = true;
        position = position - 1;
      }
    }
  }
}